# Imports
import robot_util
import requests
import urllib.request
import requests
import random
from video.ffmpeg_process import *
import audio_util
import networking
import watchdog
import subprocess
import shlex
import schedule
import extended_command
import atexit
import os
import sys
import logging
import time
import signal
import re
from twython import Twython

# Add url to images to be used as style
styles = []
styles.append('https://cdn.britannica.com/78/43678-050-F4DC8D93/Starry-Night-canvas-Vincent-van-Gogh-New-1889.jpg')


# Enter your Twitter keys here
app_key = 'YOUR KEY HERE'
app_secret = 'YOUR KEY HERE'
oauth_token = 'YOUR KEY HERE'
oauth_token_secret = 'YOUR KEY HERE'

# Create our twitter object with the keys
twitter = Twython(
    app_key, app_secret,oauth_token, oauth_token_secret
)

# Send out a tweet
def sendTweet(text, artist, fileName):

    # Message to be tweeted
    message = text + " by " + artist + '.' + ' #AI #GenerativeArt #Psycedelic #CommentToArt'

    # Open the image
    image = open(fileName, 'rb')

    # Upload the image to twitter and store it's id for later use
    response = twitter.upload_media(media=image)
    media_id = [response['media_id']]

    # Send our tweet with the message and media id
    twitter.update_status(status=message, media_ids=media_id)

# Call the text to image API
def textToImage(text):

    # Call the API
    r = requests.post(
        "https://api.deepai.org/api/text2img",
        data={
            'text': text,
        },
        headers={'api-key': 'YOUR KET HERE'}
    )

    # Fetch the result
    result = r.json()

    # Return the url of the generated image
    return result['output_url']

# Transfer the style of an artstyle and apply to the generated image
def styleTransfer(targetURL):

    # Get random style
    index = random.randint(0, len(styles)-1)
    styleUrl =styles[index]

    # Send request of two images
    r = requests.post(
        "https://api.deepai.org/api/fast-style-transfer",
        data={
            'content': targetURL,
            'style': styleUrl,
        },
        headers={'api-key': 'YOUR KEY HERE'}
    )

    # Fetch the result
    result = r.json()

    # Return the url of the generated image
    return result['output_url']

# Not sure if needed, seems important enought?
def startFFMPEG(command, name, atExit, process):

    try:
        if sys.platform.startswith('linux') or sys.platform == "darwin":
            ffmpeg_process=subprocess.Popen(command, stderr=subprocess.PIPE, shell=True, preexec_fn=os.setsid)

        globals()[process] = ffmpeg_process
    except OSError: # Can't find / execute ffmpeg
        robot_util.terminate_controller()
        return()

    if ffmpeg_process != None:
        try:
            atexit.unregister(atExit) # Only python 3
        except AttributeError:
            pass

# Mega function to delegate all the work
def generateImage(text, author):

    # Send comformation message and fecth author and text
    robot_util.sendChatMessage("Fetching supplies...")
    cleanText= re.sub('[^A-Za-z0-9]+', '', text)
    cleanUser = re.sub('[^A-Za-z0-9]+', '', author)
    time.sleep(2)

    # Generate an image from the text
    robot_util.sendChatMessage("Generating Image...")
    targetURL = textToImage(text)

    # Apply the chosen style to the generated image
    robot_util.sendChatMessage("Painting...")
    resultURL = styleTransfer(targetURL)
    imgPath = "/home/pi/remotv/img/"+ str(int(time.time()))+ '-' + cleanText + '-' + cleanUser + ".png"
    urllib.request.urlretrieve(resultURL, imgPath)

    # Start the streaming using a given image
    robot_util.sendChatMessage("Preparing showroom...")
    os.system("sudo killall ffmpeg")
    videoCommandLine = 'ffmpeg -loop 1 -i {PathToFile} -s 720x480 -t 00:00:10 -f mpegts -codec:v mpeg1video -an -b:v 2500k -muxdelay 0.001 -headers "Authorization: Bearer {robotKey}" http://remo.tv:1567/transmit?name=rbot-df663e67-4d89-480d-9014-c801f8b52a6a-video'
    videoCommandLine = videoCommandLine.format(PathToFile=imgPath, robotKey='Your Robot Key here')
    startFFMPEG(videoCommandLine, 'Video',  atExitVideoCapture, 'video_process')
    time.sleep(2.5)

    # Keeps them busy
    robot_util.sendChatMessage("Giving long opening speech...")
    time.sleep(0.2)

    # Send tweet
    robot_util.sendChatMessage("Sending Tweet...")
    sendTweet(cleanText,cleanUser,imgPath)
    time.sleep(3)

    # Showtime message!
    robot_util.sendChatMessage("Now showing a work by " + author + " called '" + text + "'")

# Again, not sure if needed, seems important enought?
def atExitVideoCapture():
    print('it dead!')

# Is needed for the main controller
def setup(robot_config):
    return

# Function called when user presses a button on Remo
def move(args, argsCustom):

    try:
        message = None
        user = None

        # In case we just started up, and nothing is said yet, but somebody presses generate
        if argsCustom is None:
            message = 'Is it me your looking at?'
            user = '8 Bits and a Byte'
        # Set raw message and auther
        else:
            message = argsCustom['message']
            user = argsCustom['sender']

        # START EVERYTHING!
        generateImage(message,user)

    # Shit went wrong, blame somebody else
    except Exception as e:
        robot_util.sendChatMessage("Hmmm, something went wrong, did you break it!?")
        time.sleep(4)
        robot_util.sendChatMessage("Nah, you're all good. Come back in like 10 min, should be al right by then")
        message = template.format(type(ex).__name__, ex.args)
        print(message)
